#include <allegro.h>
#include "eb_pong.h"

ball::ball() {
	BITMAP *temp_map;
	PALLETE pal;
	y_velocity = x_velocity = x_pos = y_pos = draw = frame = animrate = 0;
	ball_grfx[0]=create_video_bitmap(32,26);
	ball_grfx[1]=create_video_bitmap(32,26);
	ball_grfx[2]=create_video_bitmap(32,26);
	ball_grfx[3]=create_video_bitmap(32,26);
	ball_grfx[4]=create_video_bitmap(32,26);
	ball_grfx[5]=create_video_bitmap(32,26);
	ball_grfx[6]=create_video_bitmap(32,26);
	ball_grfx[7]=create_video_bitmap(32,26);
	temp_map=load_bitmap("N0.bmp",pal);
	blit(temp_map,ball_grfx[0],0,0,0,0,32,26);
	temp_map=load_bitmap("N1.bmp",pal);
	blit(temp_map,ball_grfx[1],0,0,0,0,32,26);
	temp_map=load_bitmap("N2.bmp",pal);
	blit(temp_map,ball_grfx[2],0,0,0,0,32,26);
	temp_map=load_bitmap("N3.bmp",pal);
	blit(temp_map,ball_grfx[3],0,0,0,0,32,26);
	temp_map=load_bitmap("N4.bmp",pal);
	blit(temp_map,ball_grfx[4],0,0,0,0,32,26);
	temp_map=load_bitmap("N5.bmp",pal);
	blit(temp_map,ball_grfx[5],0,0,0,0,32,26);
	temp_map=load_bitmap("N6.bmp",pal);
	blit(temp_map,ball_grfx[6],0,0,0,0,32,26);
	temp_map=load_bitmap("N7.bmp",pal);
	blit(temp_map,ball_grfx[7],0,0,0,0,32,26);
	destroy_bitmap(temp_map);
}


ball::reset_ball(int side) {
	if (side == 0) {
		x_velocity=2;
	}
	else {
		x_velocity=-2;
	}
	y_velocity=2;
	x_pos=320;
	y_pos=240;
	draw=1;
}

ball::hide_ball() {
	x_velocity=0;
	y_velocity=0;
	x_pos=320;
	y_pos=240;
	draw=0;
}

ball::update_ball() {
	if (y_pos > 465) {
		y_velocity = -2;
	}
	if (y_pos < 2) {
		y_velocity = 2;
	}
	x_pos = x_pos + x_velocity;
	y_pos = y_pos + y_velocity;
	animrate++;
	if (animrate == 6) {
		frame++;
		animrate = 0;
	}
	if (frame == 8) {
		animrate = 0;
		frame =0;
	}
}

ball::bounce_ball(int paddle_pos,ball *bball) {
	if (paddle_pos < y_pos + 40){
		if (paddle_pos + 40 > y_pos) {
			if (x_pos > 615 && x_pos < 630) {
				x_velocity = -2;
			}
			if (x_pos < 5 && x_pos > 0) {
				x_velocity = 2;
			}
		}
	}
	if (x_pos < 0) {
		bball->reset_ball(0);
		p2points++;
	}
	if (x_pos > 640) {
		bball->reset_ball(1);
		p1points++;
	}
}

ball::draw_ball() {
	acquire_bitmap(ball_grfx[frame]);
	draw_sprite(pages[page],ball_grfx[frame],x_pos,y_pos);
	release_bitmap(ball_grfx[frame]);
}

ball::~ball() {
	destroy_bitmap(ball_grfx[0]);
	destroy_bitmap(ball_grfx[1]);
	destroy_bitmap(ball_grfx[2]);
	destroy_bitmap(ball_grfx[3]);
	destroy_bitmap(ball_grfx[4]);
	destroy_bitmap(ball_grfx[5]);
	destroy_bitmap(ball_grfx[6]);
	destroy_bitmap(ball_grfx[7]);
}

paddle::paddle() {
	BITMAP *temp_map;
	PALLETE pal;
	y_pos = 240;
	paddle_grfx=create_video_bitmap(15,30);
	temp_map = load_bitmap("paddle.bmp",pal);
	blit(temp_map,paddle_grfx,0,0,0,0,15,30);
}


paddle::paddle_down() {
	y_pos=y_pos+3;
	if (y_pos > 450) {
		y_pos = 450;
	}
}

paddle::paddle_up() {
	y_pos=y_pos-3;
	if (y_pos < 0) {
		y_pos = 0;
	}
}

paddle::draw_paddle(int side) {
	acquire_bitmap(paddle_grfx);
	if (side == 0) {
		draw_sprite(pages[page],paddle_grfx,0,y_pos);
	}
	if (side == 1) {
		draw_sprite(pages[page],paddle_grfx,625,y_pos);
	}
	release_bitmap(paddle_grfx);
}


paddle::~paddle() {
	destroy_bitmap(paddle_grfx);
}


